<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info" id="btn-send"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    //sự kiện load trang
    onPageLoading();

    //thêm sự kiện change select car
    $("#car-select").on("change", function() {
      onCarSelectChange();
    });
    /*
    $("#car-select").change(function() {
      onCarSelectChange();
    });*/

    //thêm sự kiện nút send
    $("#btn-send").click(function() {
      onBtnSendClick();
    });
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện load trang
  function onPageLoading() {
    loadDataToSelectCar();
  }

  //hàm xử lý sự kiện change select car
  function onCarSelectChange() {
    var vBrandId = $("#car-select").val();
    console.log(vBrandId);

    //load dữ liệu vào select car type
    loadDataToSelectCarType(vBrandId);
  }

  //hàm xử lý sự kiện click nút send
  function onBtnSendClick() {
    var vCarSelect = $("#car-select"); 
    var vCarTypeSelect = $("#car-type-select");

    //console.log("Brand Id = " + vCarSelect.val());
    console.log("Brand Name = " + $("#car-select option:selected").val());
    console.log("Brand Name = " + $("#car-select option:selected").html());

    console.log("Type Id = " + vCarTypeSelect.val());
    console.log("Type Name = " + $("#car-type-select option:selected").html());
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm load dữ liệu vào select car
  function loadDataToSelectCar() {
    var vCarSelect = $("#car-select");

    //thêm dữ liệu vào select car
    for (var bI = 0; bI < gObjectCarData.length; bI++) {
      $("<option>", {
        value:gObjectCarData[bI].brandId,
        html:gObjectCarData[bI].brandName
      }).appendTo(vCarSelect);
    }
  }

  //hàm xử lý load dữ liệu vào select car type
  function loadDataToSelectCarType(paramBrandId) {
    //load về brandtype dựa vào brandid
    var vBrandTypes = getBrandTypeByBrandID(paramBrandId);
    
    var vCarTypeSelect = $("#car-type-select");
    //reset dữ liệu
    vCarTypeSelect.html("");

    //load dữ liệu vào car type
    if (vBrandTypes.length > 0) {//có dữ liệu
      vCarTypeSelect.prop("disabled", "");

      for (var bI = 0; bI < vBrandTypes.length; bI++) {
        $("<option>", {
          value:vBrandTypes[bI].typeId,
          html:vBrandTypes[bI].typeName
        }).appendTo(vCarTypeSelect);
      }
    } else {//không có dữ liệu
      vCarTypeSelect.prop("disabled", "disabled");
    }
  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }

</script> 

</html>